searchNodes=[{"doc":"Implements the ICU Message Format with functions to parse and interpolate messages.","ref":"Cldr.Message.html","title":"Cldr.Message","type":"module"},{"doc":"Extract the binding names from a parsed message Arguments message is a CLDR message in binary or parsed form Returns A list of variable names or {:error, {exception, reason}} Examples iex&gt; Cldr.Message . bindings &quot;This {variable} is in the message&quot; [ &quot;variable&quot; ]","ref":"Cldr.Message.html#bindings/1","title":"Cldr.Message.bindings/1","type":"function"},{"doc":"Formats a message into a canonical form. This allows for messages to be compared directly, or using Cldr.Message.jaro_distance/3 . Arguments message is a CLDR message in binary form options is a keyword list of options. The default is [] Options :trim determines if the message is trimmed of whitespace before formatting. The default is true . :pretty determines if the message if formatted with indentation to aid readability. The default is false . Returns {ok, canonical_message} where canonical_message is a binary or {:error, {exception, reason}} Examples","ref":"Cldr.Message.html#canonical_message/2","title":"Cldr.Message.canonical_message/2","type":"function"},{"doc":"Formats a message into a canonical form or raises if the message cannot be parsed. This allows for messages to be compared directly, or using Cldr.Message.jaro_distance/3 . Arguments message is a CLDR message in binary form options is a keyword list of options. The default is [] Options :trim determines if the message is trimmed of whitespace before formatting. The default is true . :pretty determines if the message if formatted with indentation to aid readability. The default is false . Returns canonical_message where canonical_message is a binary or raises an exception Examples","ref":"Cldr.Message.html#canonical_message!/2","title":"Cldr.Message.canonical_message!/2","type":"function"},{"doc":"","ref":"Cldr.Message.html#default_backend/0","title":"Cldr.Message.default_backend/0","type":"function"},{"doc":"Format a message in the ICU Message Format The ICU Message Format uses message &quot;pattern&quot; strings with variable-element placeholders enclosed in {curly braces}. The argument syntax can include formatting details, otherwise a default format is used. Arguments args is a list of map of arguments that are used to replace placeholders in the message options is a keyword list of options Options :backend :locale :trim :allow_positional_args All other aptions are passed to the to_string/2 function of a formatting module Returns Examples","ref":"Cldr.Message.html#format/3","title":"Cldr.Message.format/3","type":"function"},{"doc":"","ref":"Cldr.Message.html#format!/3","title":"Cldr.Message.format!/3","type":"function"},{"doc":"See Cldr.Message.Interpreter.format_list/3 .","ref":"Cldr.Message.html#format_list/3","title":"Cldr.Message.format_list/3","type":"function"},{"doc":"Returns the Jaro distance between two messages. This allows for fuzzy matching of message which can be helpful when a message string is changed but the semantics remain the same. Arguments message1 is a CLDR message in binary form message2 is a CLDR message in binary form options is a keyword list of options. The default is [] Options :trim determines if the message is trimmed of whitespace before formatting. The default is false . Returns {ok, distance} where distance is a float value between 0.0 (equates to no similarity) and 1.0 (is an exact match) representing Jaro distance between message1 and message2 or {:error, {exception, reason}} Examples","ref":"Cldr.Message.html#jaro_distance/3","title":"Cldr.Message.jaro_distance/3","type":"function"},{"doc":"Returns the Jaro distance between two messages or raises. This allows for fuzzy matching of message which can be helpful when a message string is changed but the semantics remain the same. Arguments message1 is a CLDR message in binary form message2 is a CLDR message in binary form options is a keyword list of options. The default is [] Options :trim determines if the message is trimmed of whitespace before formatting. The default is false . Returns distance where distance is a float value between 0.0 (equates to no similarity) and 1.0 (is an exact match) representing Jaro distance between message1 and message2 or raises an exception Examples","ref":"Cldr.Message.html#jaro_distance!/3","title":"Cldr.Message.jaro_distance!/3","type":"function"},{"doc":"","ref":"Cldr.Message.html#t:arguments/0","title":"Cldr.Message.arguments/0","type":"type"},{"doc":"","ref":"Cldr.Message.html#t:message/0","title":"Cldr.Message.message/0","type":"type"},{"doc":"","ref":"Cldr.Message.html#t:options/0","title":"Cldr.Message.options/0","type":"type"},{"doc":"","ref":"Cldr.Message.Backend.html","title":"Cldr.Message.Backend","type":"module"},{"doc":"","ref":"Cldr.Message.Backend.html#define_message_module/1","title":"Cldr.Message.Backend.define_message_module/1","type":"function"},{"doc":"Expands the given message in the given env , raising if it doesn't expand to a binary.","ref":"Cldr.Message.Backend.html#expand_to_binary/2","title":"Cldr.Message.Backend.expand_to_binary/2","type":"function"},{"doc":"","ref":"Cldr.Message.Backend.html#validate_bindings!/2","title":"Cldr.Message.Backend.validate_bindings!/2","type":"function"},{"doc":"","ref":"Cldr.Message.Interpreter.html","title":"Cldr.Message.Interpreter","type":"module"},{"doc":"Formats an ICU message into an iolist","ref":"Cldr.Message.Interpreter.html#format_list/3","title":"Cldr.Message.Interpreter.format_list/3","type":"function"},{"doc":"Implements a parser for the ICU Message format","ref":"Cldr.Message.Parser.html","title":"Cldr.Message.Parser","type":"module"},{"doc":"Parses the given binary as message. Returns {:ok, [token], rest, context, position, byte_offset} or {:error, reason, rest, context, line, byte_offset} where position describes the location of the message (start position) as {line, column_on_line} . Options :byte_offset - the byte offset for the whole binary, defaults to 0 :line - the line and the byte offset into that line, defaults to {1, byte_offset} :context - the initial context value. It will be converted to a map","ref":"Cldr.Message.Parser.html#message/2","title":"Cldr.Message.Parser.message/2","type":"function"},{"doc":"","ref":"Cldr.Message.Parser.html#parse/2","title":"Cldr.Message.Parser.parse/2","type":"function"},{"doc":"Parses the given binary as plural_message. Returns {:ok, [token], rest, context, position, byte_offset} or {:error, reason, rest, context, line, byte_offset} where position describes the location of the plural_message (start position) as {line, column_on_line} . Options :byte_offset - the byte offset for the whole binary, defaults to 0 :line - the line and the byte offset into that line, defaults to {1, byte_offset} :context - the initial context value. It will be converted to a map","ref":"Cldr.Message.Parser.html#plural_message/2","title":"Cldr.Message.Parser.plural_message/2","type":"function"},{"doc":"Exception raised when parsing an ICU message format","ref":"Cldr.Message.ParseError.html","title":"Cldr.Message.ParseError","type":"exception"},{"doc":"Exception raised when parsing an ICU message format and positional arguments are not permitted","ref":"Cldr.Message.PositionalArgsNotPermitted.html","title":"Cldr.Message.PositionalArgsNotPermitted","type":"exception"},{"doc":"Cldr Messages","ref":"readme.html","title":"Cldr Messages","type":"extras"},{"doc":"Implements the ICU Message Format for Elixir. In any application that addresses audiences from different cultures, the need arises to support the presentation of user interfaces, messages, alerts and other content in the appropriate language for a user. For nearly 30 years the go-to solution for this requirement in many computer langauges is gettext . There is a full-featured implementation for Elixir that is installed by default with Phoenix with over 10,000,000 downloads. Given the maturity and widespread adoption of Gettext , why implement another format? Leveraging the content from the Unicode CLDR project we can address some of the shortcomings of Gettext . A good description of motivations and differences can be found in this presentation by Mark Davis from Google in 2012. Two specific shortcomings that the ICU message format addresses: Grammatical Gender Many languages inflect in gender specific way. One example in French might be: # You are the only participant for a male and female Vous êtes le seul participant Vous êtes la seule participante # Married for a male and a female Mari é Mari ée In Gettext this requires individual messages and conditional code in the application in order to present the correct message to an audience. This is compounded by the fact that some languages have more than two grammatical genders (most have two and four but some are attested with up to 20). The ICU message format provides a mechanism (the choice format ) that helps translator and UX designers implement a single message to easily encapsulate messages conditional on grammatical gender (or any other selector). Standardised plural rules Although Gettext supports pluralization for messages through the Gettext.Plural module in Elixir and the Gettext functions like Gettext.ngettext/4 , the plural rules for a language have to be implemented for each message. Given the wide differences in how plural forms are structured in different languages this can be a material challenge. For example: English has two plural forms: singular and plural French applies the singular rule to two values (0 and 1) and a plural form to larger groupings Japanese does not differentiate Russian has 4 categories Arabic has 6 categories Since CLDR has a strong set of pluralization rules defined for ~500 locales, each of which is supported by ex_cldr for Elixir , the ICU message format can reuse these pluralization rules in a simple and consistent fashion using the [plural format]{#Plural_Format}.","ref":"readme.html#introduction-and-getting-started","title":"Cldr Messages - Introduction and Getting Started","type":"extras"},{"doc":"ICU message formats are Elixir strings with embedded formatting directives inserted between {} . Some examples: # Insert the binding `name` into the string &quot;My name is {name}&quot; # Insert a date, formatting in a localized `short` format plus a localized plural form # for the binding `num_photos` &quot;On {taken_date, date, short} {name} took {num_photos, plural, =0 {no photos.} =1 {one photo.} other {# photos.}}&quot; # Insert localized messages based upon the gender of the audience with # appropriate localized plural forms &quot;{gender_of_host, select, female { {num_guests, plural, offset: 1 =0 {{host} does not give a party.} =1 {{host} invites {guest} to her party.} =2 {{host} invites {guest} and one other person to her party.} other {{host} invites {guest} and # other people to her party.}}} male { {num_guests, plural, offset: 1 =0 {{host} does not give a party.} =1 {{host} invites {guest} to his party.} =2 {{host} invites {guest} and one other person to his party.} other {{host} invites {guest} and # other people to his party.}}} other { {num_guests, plural, offset: 1 =0 {{host} does not give a party.} =1 {{host} invites {guest} to their party.} =2 {{host} invites {guest} and one other person to their party.} other {{host} invites {guest} and # other people to their party.}}} }&quot;","ref":"readme.html#message-format-overview","title":"Cldr Messages - Message format overview","type":"extras"},{"doc":"Using the above messages as examples: iex&gt; Cldr.Message . format! &quot;My name is {name}&quot; , name : &quot;Kip&quot; &quot;My name is Kip&quot; iex&gt; Cldr.Message . format! &quot;On {taken_date, date, short} {name} took {num_photos, plural, =0 {no photos.} =1 {one photo.} other {# photos.}}&quot; , taken_date : Date . utc_today , name : &quot;Kip&quot; , num_photos : 10 &quot;On 8/26/19 Kip took 10 photos.&quot; As of ex_cldr_messages version 0.3.0 a macro form is introduced which parses the message at compile time in order to optimize performance at run time. To use the macro, a backend module must be imported (or required) into a module that uses formatting. For example: defmodule SomeModule do # Import a &lt;backend&gt;.Cldr.Message module import MyApp.Cldr.Message def my_function do format ( &quot;this is a string with a param {param}&quot; , param : 3 ) end end","ref":"readme.html#message-formatting","title":"Cldr Messages - Message formatting","type":"extras"},{"doc":"def deps do [ { :ex_cldr_messages , &quot;~&gt; 0.10.0&quot; } ] end Documentation is at https://hexdocs.pm/cldr_messages .","ref":"readme.html#installation","title":"Cldr Messages - Installation","type":"extras"},{"doc":"Apache License Version 2.0 , January 2004 http :/ / www . apache . org / licenses / TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License ; and (b) You must cause any modified files to carry prominent notices stating that You changed the files ; and (c) You must retain, in the Source form of any Derivative Works that You distribute , all copyright , patent , trademark , and attribution notices from the Source form of the Work , excluding those notices that do not pertain to any part of the Derivative Works ; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution , then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file , excluding those notices that do not pertain to any part of the Derivative Works , in at least one of the following places : within a NOTICE text file distributed as part of the Derivative Works ; within the Source form or documentation , if provided along with the Derivative Works ; or , within a display generated by the Derivative Works , if and wherever such third - party notices normally appear . The contents of the NOTICE file are for informational purposes only and do not modify the License . You may add Your own attribution notices within Derivative Works that You distribute , alongside or as an addendum to the NOTICE text from the Work , provided that such additional attribution notices cannot be construed as modifying the License . You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS APPENDIX: How to apply the Apache License to your work. To apply the Apache License to your work , attach the following boilerplate notice , with the fields enclosed by brackets &quot;[]&quot; replaced with your own identifying information . ( Don &#39; t include the brackets! ) The text should be enclosed in the appropriate comment syntax for the file format . We also recommend that a file or class name and description of purpose be included on the same &quot;printed page&quot; as the copyright notice for easier identification within third - party archives . Copyright 2019 Kip Cole Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http :/ / www . apache . org / licenses / LICENSE - 2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"LICENSE","type":"extras"},{"doc":"Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"This is the changelog for Cldr_Messages v0.11.0 released on May 23rd, 2021. For older changelogs please consult the release tag on GitHub Enhancements Add Cldr.Message.bindings/1 to extract the names of variable bindings for a message Add option :allow_positional_args to Cldr.Message.format/3 . The default is true . Add argument allow_positional_args? to Cldr.Message.Parser.parse/2","ref":"changelog.html#cldr_messages-v0-11-0","title":"Changelog - Cldr_Messages v0.11.0","type":"extras"},{"doc":"This is the changelog for Cldr_Messages v0.10.0 released on April 8th, 2021. For older changelogs please consult the release tag on GitHub Enhancements Use Cldr.default_backend!/0 if available","ref":"changelog.html#cldr_messages-v0-10-0","title":"Changelog - Cldr_Messages v0.10.0","type":"extras"},{"doc":"This is the changelog for Cldr_Messages v0.9.0 released on November 18th, 2019. For older changelogs please consult the release tag on GitHub Enhancements Supports number arguments to be either a number or a tuple of the form {number, keyword_list_of_formatting_options} . This provides an escape hatch for developers to influence formatting of the number beyond the textual format of the message. For example: # Uses the currency for the current locale iex&gt; Cldr.Message . format &quot;this is {one, number, currency}&quot; , one : 1 { :ok , &quot;this is $1.00&quot; } # Forces the :MXP currency iex&gt; Cldr.Message . format &quot;this is {one, number, currency}&quot; , one : { 1 , currency : :MXP } { :ok , &quot;this is MXP 1.00&quot; }","ref":"changelog.html#cldr_messages-v0-9-0","title":"Changelog - Cldr_Messages v0.9.0","type":"extras"},{"doc":"This is the changelog for Cldr_Messages v0.8.0 released on September 27th, 2019. For older changelogs please consult the release tag on GitHub Enhancements Fix Cldr.Message.Print.to_string/2 to omit blank spaces at the end of lines when pretty printing.","ref":"changelog.html#cldr_messages-v0-8-0","title":"Changelog - Cldr_Messages v0.8.0","type":"extras"},{"doc":"This is the changelog for Cldr_Messages v0.7.0 released on September 26th, 2019. For older changelogs please consult the release tag on GitHub Enhancements Allow nimble_parsec versions ~&gt; 0.5 or ~&gt; 1.0","ref":"changelog.html#cldr_messages-v0-7-0","title":"Changelog - Cldr_Messages v0.7.0","type":"extras"},{"doc":"This is the changelog for Cldr_Messages v0.6.0 released on September 26th, 2019. For older changelogs please consult the release tag on GitHub Enhancements Add Cldr.Message.canonical_message/2 that converts a string message into a canonical form. This allows for fuzzy matching between two messages that may have different formatting (this is possible since the CLDR message format allows for non-formatting whitepsace in parts of the syntax). Add documentation for some of the key functions. Much more documentation required before 1.0 release.","ref":"changelog.html#cldr_messages-v0-6-0","title":"Changelog - Cldr_Messages v0.6.0","type":"extras"},{"doc":"This is the changelog for Cldr_Messages v0.5.0 released on September 22nd, 2019. For older changelogs please consult the release tag on GitHub Enhancements Adds compile time checking that bindings are provided to the format/3 macro wherever possible Supports later versions of ex_cldr and friends, ex_money as well as Elixir 1.11 without warnings","ref":"changelog.html#cldr_messages-v0-5-0","title":"Changelog - Cldr_Messages v0.5.0","type":"extras"},{"doc":"This is the changelog for Cldr_Messages v0.4.0 released on August 29th, 2019. For older changelogs please consult the release tag on GitHub Bug Fixes Conditionally compile functions that depend on optional dependencies","ref":"changelog.html#cldr_messages-v0-4-0","title":"Changelog - Cldr_Messages v0.4.0","type":"extras"},{"doc":"This is the changelog for Cldr_Messages v0.3.0 released on August 29th, 2019. For older changelogs please consult the release tag on GitHub Breaking Changes Standardize on the Cldr.Message.format/3 as the public api. Cldr.Message.to_string/3 is removed. Enhancements Add the macro &lt;backend&gt;.Cldr.Message.format/3 to parse messages at compile time as a way to optiise performance at runtime. To use it add import &lt;backend&gt;.Cldr.Message to your module and use format/3 . An example: defmodule SomeModule do import MyApp.Cldr.Message def my_function do format ( &quot;this is a string with a param {param}&quot; , param : 3 ) end end Add Cldr.Message.format_to_list/3 formats to an io_list Bug Fixes Fix dialyzer warnings. There are some warnings from combinators that will require nimble_parsec version 0.5.2 to be published before they are resolved.","ref":"changelog.html#cldr_messages-v0-3-0","title":"Changelog - Cldr_Messages v0.3.0","type":"extras"},{"doc":"This is the changelog for Cldr_Messages v0.2.0 released on August 27th, 2019. For older changelogs please consult the release tag on GitHub Enhancements Uses Cldr.Number.to_string/3 to format simple arguments that are numeric (integer, float and decimal). This gives a localised number format. An example: iex&gt; Cldr.Message . to_string &quot;You have {number} jelly beans&quot; , number : 1234 &quot;You have 1,234 jelly beans&quot; Similarly applies localized formatting for dates, times, datetimes.","ref":"changelog.html#cldr_messages-v0-2-0","title":"Changelog - Cldr_Messages v0.2.0","type":"extras"},{"doc":"This is the changelog for Cldr_Messages v0.1.0 released on August 26th, 2019. For older changelogs please consult the release tag on GitHub Initial release. This release implements Cldr.Message.to_string/3 and Cldr.Message.format/3 This initial release is the basis for building a complete message localization solution as an alternative to Gettext . There is a long way to go until that is accomplished.","ref":"changelog.html#cldr_messages-v0-1-0","title":"Changelog - Cldr_Messages v0.1.0","type":"extras"},{"doc":"Message Format Specification Messages are user-visible strings, often with variable elements like names, numbers and dates. Message strings are typically translated into the different languages of a UI, and translators move around the variable elements according to the grammar of the target language. For this to work in many languages, a message has to be written and translated as a single unit, typically a string with placeholder syntax for the variable elements. If the user-visible string were concatenated directly from fragments and formatted elements, then translators would not be able to rearrange the pieces, and they would have a hard time translating each of the string fragments. This document is an edited version of the official ICU documentation edited to reflect the implementation in ex_cldr_messages .","ref":"message_format.html","title":"Message Format Specification","type":"extras"},{"doc":"The ICU Message Format uses message &quot;pattern&quot; strings with variable-element placeholders enclosed in {curly braces}. The argument syntax can include formatting details, otherwise a default format is used. Complex Argument Types Certain types of arguments select among several choices which are nested Message Format pattern strings. Keeping these choices together in one message pattern string facilitates translation in context, by one single translator. (Commercial translation systems often distribute different messages to different translators.) Use a &quot;plural&quot; argument to select sub-messages based on a numeric value, together with the plural rules for the specified language. Use a &quot;select&quot; argument to select sub-messages via a fixed set of keywords. Use of the old &quot;choice&quot; argument type is discouraged. It cannot handle plural rules for many languages, and is clumsy for simple selection. It is tempting to cover only a minimal part of a message string with a complex argument (e.g., plural). However, this is difficult for translators for two reasons: 1. They might have trouble understanding how the sentence fragments in the argument sub-messages interact with the rest of the sentence, and 2. They will not know whether and how they can shrink or grow the extent of the part of the sentence that is inside the argument to make the whole message work for their language. Recommendation: If possible, use complex arguments as the outermost structure of a message, and write full sentences in their sub-messages. If you have nested select and plural arguments, place the select arguments (with their fixed sets of choices) on the outside and nest the plural arguments (hopefully at most one) inside. For example: &quot;{gender_of_host, select, &quot; &quot;female {&quot; &quot;{num_guests, plural, offset:1 &quot; &quot;=0 {{host} does not give a party.}&quot; &quot;=1 {{host} invites {guest} to her party.}&quot; &quot;=2 {{host} invites {guest} and one other person to her party.}&quot; &quot;other {{host} invites {guest} and # other people to her party.}}}&quot; &quot;male {&quot; &quot;{num_guests, plural, offset:1 &quot; &quot;=0 {{host} does not give a party.}&quot; &quot;=1 {{host} invites {guest} to his party.}&quot; &quot;=2 {{host} invites {guest} and one other person to his party.}&quot; &quot;other {{host} invites {guest} and # other people to his party.}}}&quot; &quot;other {&quot; &quot;{num_guests, plural, offset:1 &quot; &quot;=0 {{host} does not give a party.}&quot; &quot;=1 {{host} invites {guest} to their party.}&quot; &quot;=2 {{host} invites {guest} and one other person to their party.}&quot; &quot;other {{host} invites {guest} and # other people to their party.}}}}&quot; Note: In a plural argument like in the example above, if the English message has both =0 and =1 (up to =offset +1) then it does not need a &quot; one &quot; variant because that would never be selected. It does always need an &quot; other &quot; variant. Note: The translation system and the translator together need to add &quot; one &quot;, &quot; few &quot; etc. if and as necessary per target language . Quoting/Escaping If syntax characters occur in the text portions, then they need to be quoted by enclosing the syntax in pairs of ASCII apostrophes. A pair of ASCII apostrophes always represents one ASCII apostrophe, similar to %% in printf representing one % , although this rule still applies inside quoted text. (&quot; This '{isn''t}' obvious &quot; → &quot; This {isn't} obvious &quot;) Recommendation: Use the real apostrophe (single quote) character ’ (U+2019) for human-readable text, and use the ASCII apostrophe ' (U+0027) only in program syntax, like quoting in Message Format. See the annotations for U+0027 Apostrophe in The Unicode Standard. Argument formatting Arguments are formatted according to their type, using the default ex_cldr formatters for those types, unless otherwise specified. For unknown types the the function to_string/0 will be called. Formatters are supported for: Numbers (integer, float and Decimal) through ex_cldr_numbers Dates, Times and DateTimes through ex_cldr_dates_times Units of measure through ex_cldr_units Money through ex_money There are also several ways to control the formatting. Predefined styles (recommended) You can specify the arg_style to be one of the predefined values short , medium , long , full (to get one of the standard forms for dates / times) and integer , currency , percent (for number formatting). Format the parameters separately (recommended) You can format the parameter as you need before calling Cldr.Message.format/3 , and then passing the resulting string as a parameter to Cldr.Message.format/3 . This offers maximum control, and is preferred to using custom format objects (see below). String patterns (discouraged) These can be used for numbers, dates, and times, but they are locale-sensitive, and they therefore would need to be localized by your translators, which adds complexity to the localization, and placeholder details are often not accessible by translators. If such a pattern is not localized, then users see confusing formatting. Consider using skeletons instead of patterns in your message strings. Allowing translators to localize date patterns is error-prone, as translators might make mistakes (resulting in invalid CLDR date formatter syntax). Also, CLDR provides curated patterns for many locales, and using your own pattern means that you don't benefit from that CLDR data and the results will likely be inconsistent with the rest of the patterns that CLDR uses. It is also a bad internationalization practice, because most companies only translate into &quot;generic&quot; versions of the languages (French, or Spanish, or Arabic). So the translated patterns get used in tens of countries. On the other hand, skeletons are localized according to the locale, which should include regional variants (e.g., “fr-CA”).","ref":"message_format.html#message-format-overview","title":"Message Format Specification - Message Format Overview","type":"extras"},{"doc":"ex_cldr_messages prepares strings for display to users, with optional arguments (variables/placeholders). The arguments can occur in any order, which is necessary for translation into languages with different grammars. A message is constructed from a pattern string with arguments in {curly braces} which will be replaced by formatted values. Arguments can be named (using identifiers) or numbered (using small ASCII-digit integers). An argument might not specify any format type. In this case, a Number value is formatted with a default (for the locale) Number Format, a Date value is formatted with a default (for the locale) Date Format, and so on for a Unit, Money and Curency. For any other value its to_string/0 is called. An argument might specify a &quot;simple&quot; type for which the specified Format object is created, cached and used. An argument might have a &quot;complex&quot; type with nested MessageFormat sub-patterns. During formatting, one of these sub-messages is selected according to the argument value and recursively formatted. When formatting, Cldr.Message.format/3 takes a collection of argument values and writes an output string. The argument values may be passed as a list (when the pattern contains only numbered arguments) or as a Map (which works for both named and numbered arguments). Each argument is matched with one of the input values by list index or map key and formatted according to its pattern specification. A numbered pattern argument is matched with a map key that contains that number as an ASCII-decimal-digit string (without leading zero). Patterns and Their Interpretation Message Format uses patterns of the following form: message = messageText ( argument messageText ) * argument = noneArg | simpleArg | complexArg complexArg = choiceArg | pluralArg | selectArg | selectordinalArg noneArg = &#39;{&#39; argNameOrNumber &#39;}&#39; simpleArg = &#39;{&#39; argNameOrNumber &#39;,&#39; argType [ &#39;,&#39; argStyle ] &#39;}&#39; choiceArg = &#39;{&#39; argNameOrNumber &#39;,&#39; &quot;choice&quot; &#39;,&#39; choiceStyle &#39;}&#39; pluralArg = &#39;{&#39; argNameOrNumber &#39;,&#39; &quot;plural&quot; &#39;,&#39; pluralStyle &#39;}&#39; selectArg = &#39;{&#39; argNameOrNumber &#39;,&#39; &quot;select&quot; &#39;,&#39; selectStyle &#39;}&#39; selectordinalArg = &#39;{&#39; argNameOrNumber &#39;,&#39; &quot;selectordinal&quot; &#39;,&#39; pluralStyle &#39;}&#39; choiceStyle : see ChoiceFormat pluralStyle : see PluralFormat selectStyle : see SelectFormat argNameOrNumber = argName | argNumber argName = [ ^ [ [ :Pattern_Syntax : ] [ :Pattern_White_Space : ] ] ] + argNumber = &#39;0&#39; | ( &#39;1&#39; .. &#39;9&#39; ( &#39;0&#39; .. &#39;9&#39; ) * ) argType = &quot;number&quot; | &quot;date&quot; | &quot;time&quot; | &quot;spellout&quot; | &quot;ordinal&quot; | &quot;duration&quot; argStyle = &quot;short&quot; | &quot;medium&quot; | &quot;long&quot; | &quot;full&quot; | &quot;integer&quot; | &quot;currency&quot; | &quot;percent&quot; | argStyleText Messages can contain quoted literal strings including syntax characters. A quoted literal string begins with an ASCII apostrophe and a syntax character (usually a {curly brace}) and continues until the next single apostrophe. A double ASCII apostrophe inside or outside of a quoted string represents one literal apostrophe. Quotable syntax characters are the {curly braces} in all message parts, plus the # sign in a message immediately inside a pluralStyle , and the '|' symbol in a messageText immediately inside a choiceStyle . In argStyleText, every single ASCII apostrophe begins and ends quoted literal text, and unquoted {curly braces} must occur in matched pairs. Recommendation: Use the real apostrophe (single quote) character \\u2019 for human-readable text, and use the ASCII apostrophe (\\u0027 ' ) only in program syntax, like quoting in MessageFormat. See the annotations for U+0027 Apostrophe in The Unicode Standard. The choice argument type is deprecated. Use plural arguments for proper plural selection, and select arguments for simple selection among a fixed set of choices. Examples See the examples in the README","ref":"message_format.html#message-format-syntax","title":"Message Format Specification - Message Format Syntax","type":"extras"}]